summaryrefslogtreecommitdiffstats
path: root/p7zip
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2008-03-19 21:33:51 +0000
committer Eric Hameleers <alien@slackware.com>2008-03-19 21:33:51 +0000
commit4ea10ee6ee59123dc596e6e390449bad86a37d19 (patch)
tree58302df5912308ff2e930c30efba746a7c59634d /p7zip
parentf05838b9202189bc29c3d1e6adf500f73003a137 (diff)
downloadasb-4ea10ee6ee59123dc596e6e390449bad86a37d19.tar.gz
asb-4ea10ee6ee59123dc596e6e390449bad86a37d19.tar.xz
Updated for Slackware 12.0 and a new version of the software, 4.57
Diffstat (limited to 'p7zip')
-rwxr-xr-xp7zip/build/p7zip.SlackBuild294
1 files changed, 136 insertions, 158 deletions
diff --git a/p7zip/build/p7zip.SlackBuild b/p7zip/build/p7zip.SlackBuild
index ce405e83..01fae361 100755
--- a/p7zip/build/p7zip.SlackBuild
+++ b/p7zip/build/p7zip.SlackBuild
@@ -1,69 +1,110 @@
#!/bin/sh
# $Id$
-# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
-# Distributed under the terms of the GNU General Public License, Version 2
+# Copyright (c) 2006-2008 Eric Hameleers <alien@slackware.com>
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script
# ===========================
-# By: Eric Hameleers <alien@slackware.com>
-# For: p7zip
-# URL: http://www.7-zip.org/
-# Needs:
-# Changelog:
+# By: Eric Hameleers <alien@slackware.com>
+# For: p7zip
+# Descr: file archiver with high compression rates
+# URL: http://www.7-zip.org/
+# Needs:
+# Changelog:
# 4.30-1: 13/jan/2006 by Eric Hameleers <alien@slackware.com>
# * Initial build.
# 4.42-1: 29/jul/2006 by Eric Hameleers <alien@slackware.com>
# * Update.
+# 4.57-1: 19/mar/2008 by Eric Hameleers <alien@slackware.com>
+# * Update. Check for gcc version. Use 'make install' instead of
+# manually copying files.
#
-# Run 'sh SlackBuild --cleanup' to build a Slackware package.
+# Run 'sh p7zip.SlackBuild --cleanup' to build a Slackware package.
# The package (.tgz) plus descriptive .txt file are created in /tmp .
# Install using 'installpkg'.
#
# -----------------------------------------------------------------------------
-# --- INIT ---
# Set initial variables:
-CWD=`pwd`
-if [ "$TMP" = "" ]; then
- TMP=/tmp
-fi
PRGNAM=p7zip
-VERSION=4.42
+VERSION=${VERSION:-4.57}
ARCH=${ARCH:-i486}
-BUILD=1
+BUILD=${BUILD:-1}
-DOCS="ChangeLog DOCS/* README TODO"
-PREDOC="mv DOCS/MANUAL DOCS/html"
+DOCS="ChangeLog README TODO"
-# If you have more source files, list them here as SOURCE[1], SOURCE[2], etc.
-# If you know the URL for a source file, you can put that into the SRCURL[]
-# variable, and the SlackBuild script will try to download it for you.
+# Where do we look for sources?
+CWD=$(pwd)
+SRCDIR=$(dirname $0)
+[ "${SRCDIR:0:1}" == "." ] && SRCDIR=${CWD}/${SRCDIR}
-SOURCE[0]="${PRGNAM}_${VERSION}.tar.bz2"
-SRCURL[0]="http://ovh.dl.sourceforge.net/sourceforge/${PRGNAM}/${PRGNAM}_${VERSION}_src_all.tar.bz2"
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}_${VERSION}_src_all.tar.bz2"
+SRCURL="http://downloads.sourceforge.net/${PRGNAM}/${PRGNAM}_${VERSION}_src_all.tar.bz2"
##
## --- with a little luck, you won't have to edit below this point --- ##
##
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Slackware 11 and up need other option (gcc > 3.3.x)
+if [ $(gcc -dumpversion | tr -d '.' |cut -c 1-2) -gt 40 ]; then
+ ARCHEXTRA="_gcc_4.X"
+else
+ ARCHEXTRA=""
+fi
+if [ $(gcc -dumpversion | tr -d '.' |cut -c 1-2) -gt 33 ]; then
+ MOPT=tune
+else
+ MOPT=cpu
+fi
+
case "$ARCH" in
- i386) SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+ i386) SLKCFLAGS="-O2 -march=i386 -m${MOPT}=i686"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ARCHSUFFIX="x86_ppc_alpha"
+ ARCHSUFFIX="x86_ppc_alpha${ARCHEXTRA}"
;;
- i486) SLKCFLAGS="-O2 -march=i486 -mcpu=i686"
+ i486) SLKCFLAGS="-O2 -march=i486 -m${MOPT}=i686"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ARCHSUFFIX="x86_ppc_alpha"
+ ARCHSUFFIX="x86_ppc_alpha${ARCHEXTRA}"
;;
s390) SLKCFLAGS="-O2"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ARCHSUFFIX="x86_ppc_alpha"
+ ARCHSUFFIX="x86_ppc_alpha${ARCHEXTRA}"
;;
powerpc) SLKCFLAGS="-O2"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ARCHSUFFIX="x86_ppc_alpha"
+ ARCHSUFFIX="x86_ppc_alpha${ARCHEXTRA}"
;;
x86_64) SLKCFLAGS="-O2 -fPIC"
SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
@@ -71,46 +112,37 @@ case "$ARCH" in
;;
athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ARCHSUFFIX="x86_ppc_alpha"
+ ARCHSUFFIX="x86_ppc_alpha${ARCHEXTRA}"
;;
esac
-PKG=$TMP/package-$PRGNAM
-
-if [ ! -d $TMP/tmp-$PRGNAM ]; then
- mkdir -p $TMP/tmp-$PRGNAM # location to build the source
-elif [ "$1" != "--oldbuild" ]; then
- # If the "--oldbuild" parameter is present, we keep
- # the old build files and continue;
- # By default we remove the remnants of previous build and continue:
- rm -rf $TMP/tmp-$PRGNAM/*
-fi
-
-if [ ! -d $PKG ]; then
- mkdir -p $PKG # place for the package to be built
-fi
-
-
-# --- SOURCE FILE AVAILABILITY ---
-
-for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
- if ! [ -f ${CWD}/${SOURCE[$i]} ]; then
- if ! [ "${SRCURL[$i]}" = "" ]; then
- echo "Source '${SOURCE[$i]}' not available yet... will download now:"
- wget -nv -O "${CWD}/${SOURCE[$i]}" "${SRCURL[$i]}"
- if [ $? -ne 0 ]; then
- echo "Downloading '${SOURCE[$i]}' failed... aborting the build."
- mv -f "${CWD}/${SOURCE[$i]}" "${CWD}/${SOURCE[$i]}".FAIL
- exit 1
- fi
- else
- echo "File '${SOURCE[$i]}' not available... aborting the build."
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ if ! [ "x${SRCURL}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
exit 1
fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
fi
-done
+fi
-if [ "$1" == "--download" ]; then
+if [ "$P1" == "--download" ]; then
echo "Download complete."
exit 0
fi
@@ -121,122 +153,68 @@ echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"
-# Safety net 8-)
-if [ "$PKG" = "" -o "$PKG" = "/" ] ; then
- cat <<-EOT
- Your script sucks!!!
- You were about to delete the contents of your computer's hard disk!
- Please provide a value for the variable 'PKG'.
- EOT
- exit 1
-fi
-# We always erase old package's contents:
-rm -rf $PKG/*
-
-cd $PKG
-
-# Explode the package framework:
-if [ -f $CWD/_$PRGNAM.tar.gz ]; then
- explodepkg $CWD/_$PRGNAM.tar.gz
-fi
-
cd $TMP/tmp-$PRGNAM
-
-
-# --- TARBALL EXTRACTION,PATCH,MODIFY ---
-
-echo "Extracting the program tarball(s) for $PRGNAM..."
-for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
- if `file $CWD/${SOURCE[$i]} | grep -q ": bzip2"`; then
- tar -xjvf $CWD/${SOURCE[$i]}
- elif `file $CWD/${SOURCE[$i]} | grep -qi ": zip"`; then
- unzip $CWD/${SOURCE[$i]}
- else
- tar -xzvf $CWD/${SOURCE[$i]}
- fi
-done
+echo "Extracting the source archive(s) for $PRGNAM..."
+if $(file ${SOURCE} | grep -q ": bzip2"); then
+ tar -xjvf ${SOURCE}
+elif $(file ${SOURCE} | grep -q ": gzip"); then
+ tar -xzvf ${SOURCE}
+fi
mv ${PRGNAM}_${VERSION} ${PRGNAM}-${VERSION}
cd ${PRGNAM}-${VERSION}
-
-chown -R root:root *
-find . -perm 777 -exec chmod 755 {} \;
-
-
-# --- BUILDING ---
+chown -R root:root .
+chmod -R u+w,go+r-w,a-s .
echo Building ...
-
cp -f makefile.linux_${ARCHSUFFIX} makefile.machine
-make -j 3 all2 2>&1 | tee $CWD/make-${PRGNAM}.log
+make OPTFLAGS="$SLKCFLAGS" DEST_HOME=/usr DEST_SHARE_DOC=/usr/doc/${PRGNAM}-${VERSION} all3 \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
-#
# Install all the needed stuff to the package dir
-#
-mkdir -p $PKG/usr/bin
-mkdir -p $PKG/usr/man/man1
-mkdir -p $PKG/usr/libexec/$PRGNAM
-cp -ap bin/* $PKG/usr/libexec/$PRGNAM
-cp -ap man1/* $PKG/usr/man/man1
-
-# Create the wrapper scripts
-cat > $PKG/usr/bin/7za <<EOF
-#!/bin/sh
-exec /usr/libexec/$PRGNAM/7za "\$@"
-EOF
-
-cat > $PKG/usr/bin/7z <<EOF
-#!/bin/sh
-exec /usr/libexec/$PRGNAM/7z "\$@"
-EOF
-
-
-# --- DOCUMENTATION ---
+# Use installwatch if available, to produce a logfile of the installation
+# process that is more easily readable:
+if $(which installwatch > /dev/null 2>&1); then
+ installwatch -o $OUTPUT/install-${PRGNAM}.log make DEST_HOME=/usr DEST_SHARE_DOC=/usr/doc/${PRGNAM}-${VERSION} DEST_DIR=$PKG install
+else
+ make DEST_HOME=/usr DEST_SHARE_DOC=/usr/doc/${PRGNAM}-${VERSION} DEST_DIR=$PKG install 2>&1 |tee $OUTPUT/install-${PRGNAM}.log
+fi
+# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-$PREDOC
-cp -a $DOCS \
- $PKG/usr/doc/$PRGNAM-$VERSION
-chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
-
-# Compress the man page(s)
-find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
-
-# Strip binaries
-( cd $PKG
- find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
- find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
-)
-
-
-# --- OWNERSHIP, RIGHTS ---
-
-chmod -R o-w $PKG
-chmod 755 $PKG/usr/bin/*
-
+mv $PKG/usr/doc/$PRGNAM-$VERSION/DOCS/* $PKG/usr/doc/$PRGNAM-$VERSION/ && \
+ rmdir $PKG/usr/doc/$PRGNAM-$VERSION/DOCS
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
-# --- PACKAGE DESCRIPTION ---
+# Strip binaries:
+cd $PKG
+find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+cd -
+# Add a package description:
mkdir -p $PKG/install
-cat $CWD/slack-desc > $PKG/install/slack-desc
-if [ -f $CWD/doinst.sh ]; then
- cat $CWD/doinst.sh > $PKG/install/doinst.sh
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
fi
-
-# --- BUILDING ---
-
# Build the package:
cd $PKG
-makepkg --linkadd y --chown n $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz \
- 2>&1 | tee $CWD/makepkg-${PRGNAM}.log
-(cd $TMP && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
-cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
-
-
-# --- CLEANUP ---
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
# Clean up the extra stuff:
-if [ "$1" = "--cleanup" ]; then
+if [ "$P1" = "--cleanup" ]; then
rm -rf $TMP/tmp-$PRGNAM
rm -rf $PKG
fi